// Program: Lesson 23, Exercise 4

#include <iostream.h>

class chain {
 public:
   chain(int num);
   ~chain(void);
   void print(char* string);

 private:
   int     my_num;
   chain*  next;
 };

chain :: chain(int num)
 {
   my_num = num;
   if (num)
     next = new chain (num-1);
   else
     next = NULL;
 }

chain :: ~chain(void)
 {
   if (next != NULL)
     delete next;
 }

void chain :: print(char *string)
 {
   cout << my_num << ": " << string << endl;

   if (my_num)
     next -> print(string);
 }

void main(void)
 {
    chain *c = new chain(7);

    c -> print ("We are a ring!!");

    delete c;
 }
