// Program: Lesson 25, Exercise 1

#include <iostream.h>
#include <iomanip.h>

class Object {
 public:
   Object(void) { x = y = z = w = 0; }

   int x;
   static int y;

   void print(void);
   static void output_message(void);

 private:
   int w;
   static int z;
 };

int Object::y;
int Object::z;

void Object::print(void)
 {
    cout << x << " " << y << " " << w << " " << z << endl;
 }

void Object::output_message(void)
 {
    cout << "This program demonstrates the use of static methods and data members" << endl;
 }

void main(void)
 {
    Object::output_message(); // use before object creation -- legal because
                              // 'output_message' is a static PUBLIC method


    Object::y = 9;   // use before object creation -- legal because
                     // 'y' is a static PUBLIC data member

    // Object::z = 17; -- illegal becuase 'z' is a static PRIVATE data member
   
    Object s1, s2;

    s1.x = 5;
    s1.print();

    s2.x = 7;
    s2.y = 3;
    s2.print();
    s1.print();

    Object s3;
    s1.print();
    s2.print();
    s1.y = 4;
    s3.print();
 }
