// Program: Lesson 29, Exercise 4

#include <iostream.h>

template<class T> void swap(T& a, T& b)
 {
   T tmp = a;
   a = b;
   b = tmp;
 }

template<class T> void sort(T* a, int length)
// this is the famous bubble sort algorithm
 {
   for (int i = length-1; i >= 0; --i)
      for (int j = 1; j <= i; ++j)
	 if (a[j] < a[j-1])
	   swap(a[j], a[j-1]);
 }

template<class T> void show(T* a, int length)
 {
   for (int i = 0; i < length; ++i)
      cout << a[i] << " ";
   cout << endl;
 }

void sort(int*, int);
void show(int*, int);
void swap(int&, int&);

void main(void)
 {
   int a[10] = {6, 4, 8, 1, -3, 2, 11, 13, 0, 9};

   show(a, 10);
   sort(a, 10);
   show(a, 10);
 }



