// Program: Lesson 38 - Excercise 4

#include <iostream.h>

class shape {
 public:
   virtual float area(void) =0;
 };

class rectangle : public shape {
 public:
   rectangle (float height, float width) { rectangle::height = height;
					   rectangle::width  = width;  }

   virtual float area(void) { return height * width; }
 protected:
   float height;
   float width;
 };

class square : public rectangle {
 public:
   square (float height) : rectangle (height, height) {}
   float area(void) { return height * height; }
   float circumference(void) { return 4 * height; }
 };

void main(void)
 {
    shape* s1;
    square* s2;

    s1 = new rectangle(4, 7);
    cout << s1->area() << endl;
    s2 = new square(5);
    cout << s2->area() << endl;
    cout << s2->circumference() << endl;
    s1 = s2;
    cout << s1->area() << endl;
    // NOTE THAT THIS IS ILLEGAL: s1->circumference()
    // because circumference is NOT a (VIRTUAL) MEMBER of shape
 }
