#include <iostream.h>
#include <string.h>

class book {
 public:
   book(char *, char *, char *);
   void show_book(void);
   friend librarian;
 private:
   char title[64];
   char author[64];
   char catalog[64];
};

book::book(char *title, char *author, char *catalog)
 {
   strcpy(book::title, title);   
   strcpy(book::author, author);
   strcpy(book::catalog, catalog);
 }

void book::show_book(void)
 {
   cout << "Title: " << title << endl;
   cout << "Author: " << author << endl;
   cout << "Catalog: " << catalog << endl;
 }

class librarian {
 public:
   void change_catalog(book *, char *);
   char *get_catalog(book);
};

void librarian::change_catalog(book *this_book, char *new_catalog)
 {
   strcpy(this_book->catalog, new_catalog);
 }

char *librarian::get_catalog(book this_book)
 {
   static char catalog[64];

   strcpy(catalog, this_book.catalog);
   return(catalog);
 }

void main(void)
 {
   book programming("Rescued By C++", "Jamsa", "P101");
   librarian library;

   programming.show_book();
   
   library.change_catalog(&programming, "EASY C+ 101");

   programming.show_book();
 }


