// Program: Lesson 23, Exercise 2

#include <iostream.h>

class Point {
 public:

   Point (float = 0, float = 0);
   ~Point(void);
   void  print(void);

 private:
   // the point coordinates
   float x;
   float y;
 };

Point::Point(float x_val, float y_val)
 {
    x = x_val;
    y = y_val;
   
    cout << "point "; 
    print();
    cout << " created" << endl;
 }

Point::~Point(void)
 {
    cout << "point "; 
    print();
    cout << " destroyed" << endl;
 }

void Point::print(void)
 {
    cout << '(' << x << ',' << y << ')';
 }

void main(void)
 {
    Point p1(5.5,7.3), p2(5.2), p3(0,4.4), p4;

    p1.print();
    p2.print();
    p3.print();
    p4.print();

    cout << endl;  // so destruction messages will start in a new line
 }
